Subject: Execute native prepared queries in t3lib_DB
Description

Currently, t3lib_DB does not execute prepared queries, even when the prepared functions are used. All queries are transformed to
"normal" MySQL queries. Only DBAL takes advantage of using them ATM.

This should be fixed for 4.6 I think.

Related issues:
related to Core - Feature # 23374: Add support for prepared queries Resolved 2010-08-14

Associated revisions
Revision 5487900c - 2014-03-18 11:39 - Xavier Perseguers

[FEATURE] Execute native prepared queries

As TYPO3 is now using mysqli, prepared queries are natively supported
and should be used.

DBAL, however, does not yet actually use native prepared queries but
falls back to standard queries by replacing placeholders and executing
the underlying SQL query.
History
#1 - 2014-01-14 17:10 - Benjamin Mack
- File prepared_statements_wip.patch added
https://review.typo3.org/28231


wip patch attached. Xavier will work on this in the next weeks.

#2 - 2014-01-16 17:59 - Ernesto Baschny
- Status changed from New to Accepted
- Target version set to 6.2.0

+1 on that, thanks!

#3 - 2014-01-27 16:39 - Felix Oertel

Do we have current status? ;)

#4 - 2014-01-30 16:39 - Ingo Schmitt
- Parent task set to #55179

#5 - 2014-03-05 13:24 - Markus Klein
- Target version deleted (6.2.0)
- Complexity set to hard

I took a closer look here.

To sum it up: quite hard

    1. Our DB API supports named parameters (:placeholder), but MySQL does not.
    2. The patch from Benni does not take DBAL into account at all. So this is a no go.
    3. The mysqli_stmt::get_result() (buffered result) method is only available with mysqlnd driver according to php docs.

We'd need to:

    1. Get DBAL straight for 6.2 (#50752)
    2. Implement a translation layer from named to positioned parameters, which would involve some sort of query parsing again.
    3. Make the PreparedStatement class independent of any database link, as the exact link used is different for every driver used in DBAL.
    4. Emulate a buffered result, if mysqlnd is not available, to make the PreparedStatement::seek() function work

So IMHO this is a topic for 6.3+

#6 - 2014-03-10 15:46 - Felix Oertel
- Assigned To set to Xavier Perseguers
- Target version set to 6.2.0
- TYPO3 Version changed from 4.6 to 6.2

Xavier will work on this and tries to push a WIP patch this evening. In the morning I will have a look and possibly pick up ...

#7 - 2014-03-10 17:07 - Gerrit Code Review
- Status changed from Accepted to Under Review
Patch set 1 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/28231

#8 - 2014-03-10 18:29 - Gerrit Code Review

Patch set 2 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/28231

#9 - 2014-03-10 18:33 - Gerrit Code Review

Patch set 3 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/28231

#10 - 2014-03-10 20:15 - Gerrit Code Review

Patch set 4 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/28231

#11 - 2014-03-12 15:26 - Gerrit Code Review

Patch set 5 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/28231

#12 - 2014-03-12 17:00 - Gerrit Code Review

Patch set 6 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/28231

#13 - 2014-03-12 22:27 - Gerrit Code Review

Patch set 7 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/28231

#14 - 2014-03-13 11:21 - Gerrit Code Review

Patch set 8 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/28231

#15 - 2014-03-17 12:35 - Gerrit Code Review

Patch set 9 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/28231
#16 - 2014-03-18 12:30 - Xavier Perseguers
- Status changed from Under Review to Resolved
- % Done changed from 0 to 100

Applied in changeset commit:5487900c5ad094cd8dc733f5e8cdc627673e94ff.

Files
prepared_statements_wip.patch 9.5 kB 2014-01-14 Benjamin Mack
